#include <iostream>
using namespace std;

#include <iomanip>
#include <string>
#include <fstream>
#include <cmath>
#include <vector>

#include "memAlloc.h"

void main()
{
	int i, j, k, m, dummy_int;
	int var_type_1a, var_type_2a, var_type_3a, var_type_1b, var_type_2b, var_type_3b;
	char infilename[100], scen_or_cntr[10];
	char GT_LT_1a[5], GT_LT_2a[5], GT_LT_3a[5], GT_LT_1b[5], GT_LT_2b[5], GT_LT_3b[5];

	char second_var_condition_1b[6], second_var_condition_2b[6], second_var_condition_3b[6];
	char var_1a[10], var_1b[10],var_2a[10], var_2b[10],var_3a[10], var_3b[10];

	char outfilename_1a_count[100], outfilename_2a_count[100], outfilename_3a_count[100];
	char outfilename_1a_sum[100], outfilename_2a_sum[100], outfilename_3a_sum[100];

	double thresh_1a, thresh_2a, thresh_3a, thresh_1b, thresh_2b, thresh_3b;
	int *date_time = new int [6];
	double *data_vector = new double [10];
	
	int nsims=100;

	double **count_vec_1 = matrix2D_real(nsims, 13);
	double **count_vec_2 = matrix2D_real(nsims, 13);
	double **count_vec_3 = matrix2D_real(nsims, 13);

	double **sum_of_diffs_1 = matrix2D_real(nsims, 13);
	double **sum_of_diffs_2 = matrix2D_real(nsims, 13);	
	double **sum_of_diffs_3 = matrix2D_real(nsims, 13);

	int **no_of_points = matrix2D_int(nsims, 13);


	bool GT_LT_bool_1a, GT_LT_bool_2a, GT_LT_bool_3a, GT_LT_bool_1b, GT_LT_bool_2b, GT_LT_bool_3b;
	bool second_var_condition_1b_bool, second_var_condition_2b_bool, second_var_condition_3b_bool;


	cout << "Runnning threshold detector...please wait" << endl;

	ifstream ini_file("CRU_WG_dly_TD_ini.txt");
	if (!ini_file) cout << "Error opening ini file" << endl;
		
	ini_file >> infilename;					// line 1
	ini_file >> scen_or_cntr;				// line 2

	ini_file >> var_type_1a;				// line 3

	ini_file >> GT_LT_1a;					// line 4
	ini_file >> thresh_1a;					// line 5

	ini_file >> second_var_condition_1b;	// line 6
	ini_file >> var_type_1b;				// line 7

	ini_file >> GT_LT_1b;					// line 8
	ini_file >> thresh_1b;					// line 9
//////////////////////////////////////////////////////////////
	ini_file >> var_type_2a;				// line 10

	ini_file >> GT_LT_2a;					// line 11
	ini_file >> thresh_2a;					// line 12

	ini_file >> second_var_condition_2b;	// line 13
	ini_file >> var_type_2b;				// line 14

	ini_file >> GT_LT_2b;					// line 15
	ini_file >> thresh_2b;					// line 16
//////////////////////////////////////////////////////////////
	ini_file >> var_type_3a;				// line 17

	ini_file >> GT_LT_3a;					// line 18
	ini_file >> thresh_3a;					// line 19

	ini_file >> second_var_condition_3b;	// line 20
	ini_file >> var_type_3b;				// line 21

	ini_file >> GT_LT_3b;					// line 22
	ini_file >> thresh_3b;					// line 23

//////////////////////////////////////////////////////////
	if (var_type_1a == 0)
	{
		strcpy(var_1a,"RN");
	}
	else if (var_type_1a == 1)
	{
		strcpy(var_1a,"Tmin");
	}
	else if (var_type_1a == 2)
	{
		strcpy(var_1a,"Tmax");
	}
	else if (var_type_1a == 3)
	{
		strcpy(var_1a,"VP");
	}
	else if (var_type_1a == 4)
	{
		strcpy(var_1a,"RH");
	}
	else if (var_type_1a == 5)
	{
		strcpy(var_1a,"WN");
	}
	else if (var_type_1a == 6)
	{
		strcpy(var_1a,"SS");
	}
	else if (var_type_1a == 7)
	{
		strcpy(var_1a,"diffradt");
	}
	else if (var_type_1a == 8)
	{
		strcpy(var_1a,"dirradt");
	}
	else if (var_type_1a == 9)
	{
		strcpy(var_1a,"PET");
	}
//////////////////////////////////////////////////////////
	if (var_type_1b == 0)
	{
		strcpy(var_1b,"RN");
	}
	else if (var_type_1b == 1)
	{
		strcpy(var_1b,"Tmin");
	}
	else if (var_type_1b == 2)
	{
		strcpy(var_1b,"Tmax");
	}
	else if (var_type_1b == 3)
	{
		strcpy(var_1b,"VP");
	}
	else if (var_type_1b == 4)
	{
		strcpy(var_1b,"RH");
	}
	else if (var_type_1b == 5)
	{
		strcpy(var_1b,"WN");
	}
	else if (var_type_1b == 6)
	{
		strcpy(var_1b,"SS");
	}
	else if (var_type_1b == 7)
	{
		strcpy(var_1b,"diffradt");
	}
	else if (var_type_1b == 8)
	{
		strcpy(var_1b,"dirradt");
	}
	else if (var_type_1b == 9)
	{
		strcpy(var_1b,"PET");
	}
//////////////////////////////////////////////////////////
	if (var_type_2a == 0)
	{
		strcpy(var_2a,"RN");
	}
	else if (var_type_2a == 1)
	{
		strcpy(var_2a,"Tmin");
	}
	else if (var_type_2a == 2)
	{
		strcpy(var_2a,"Tmax");
	}
	else if (var_type_2a == 3)
	{
		strcpy(var_2a,"VP");
	}
	else if (var_type_2a == 4)
	{
		strcpy(var_2a,"RH");
	}
	else if (var_type_2a == 5)
	{
		strcpy(var_2a,"WN");
	}
	else if (var_type_2a == 6)
	{
		strcpy(var_2a,"SS");
	}
	else if (var_type_2a == 7)
	{
		strcpy(var_2a,"diffradt");
	}
	else if (var_type_2a == 8)
	{
		strcpy(var_2a,"dirradt");
	}
	else if (var_type_2a == 9)
	{
		strcpy(var_2a,"PET");
	}
//////////////////////////////////////////////////////////
	if (var_type_2b == 0)
	{
		strcpy(var_2b,"RN");
	}
	else if (var_type_2b == 1)
	{
		strcpy(var_2b,"Tmin");
	}
	else if (var_type_2b == 2)
	{
		strcpy(var_2b,"Tmax");
	}
	else if (var_type_2b == 3)
	{
		strcpy(var_2b,"VP");
	}
	else if (var_type_2b == 4)
	{
		strcpy(var_2b,"RH");
	}
	else if (var_type_2b == 5)
	{
		strcpy(var_2b,"WN");
	}
	else if (var_type_2b == 6)
	{
		strcpy(var_2b,"SS");
	}
	else if (var_type_2b == 7)
	{
		strcpy(var_2b,"diffradt");
	}
	else if (var_type_2b == 8)
	{
		strcpy(var_2b,"dirradt");
	}
	else if (var_type_2b == 9)
	{
		strcpy(var_2b,"PET");
	}
//////////////////////////////////////////////////////////
	if (var_type_3a == 0)
	{
		strcpy(var_3a,"RN");
	}
	else if (var_type_3a == 1)
	{
		strcpy(var_3a,"Tmin");
	}
	else if (var_type_3a == 2)
	{
		strcpy(var_3a,"Tmax");
	}
	else if (var_type_3a == 3)
	{
		strcpy(var_3a,"VP");
	}
	else if (var_type_3a == 4)
	{
		strcpy(var_3a,"RH");
	}
	else if (var_type_3a == 5)
	{
		strcpy(var_3a,"WN");
	}
	else if (var_type_3a == 6)
	{
		strcpy(var_3a,"SS");
	}
	else if (var_type_3a == 7)
	{
		strcpy(var_3a,"diffradt");
	}
	else if (var_type_3a == 8)
	{
		strcpy(var_3a,"dirradt");
	}
	else if (var_type_3a == 9)
	{
		strcpy(var_3a,"PET");
	}
//////////////////////////////////////////////////////////
	if (var_type_3b == 0)
	{
		strcpy(var_3b,"RN");
	}
	else if (var_type_3b == 1)
	{
		strcpy(var_3b,"Tmin");
	}
	else if (var_type_3b == 2)
	{
		strcpy(var_3b,"Tmax");
	}
	else if (var_type_3b == 3)
	{
		strcpy(var_3b,"VP");
	}
	else if (var_type_3b == 4)
	{
		strcpy(var_3b,"RH");
	}
	else if (var_type_3b == 5)
	{
		strcpy(var_3b,"WN");
	}
	else if (var_type_3b == 6)
	{
		strcpy(var_3b,"SS");
	}
	else if (var_type_3b == 7)
	{
		strcpy(var_3b,"diffradt");
	}
	else if (var_type_3b == 8)
	{
		strcpy(var_3b,"dirradt");
	}
	else if (var_type_3b == 9)
	{
		strcpy(var_3b,"PET");
	}
//////////////////////////////////////////////////////////
	if (strcmp(GT_LT_1a,"GT") == 0)
	{
		GT_LT_bool_1a = true;
	}
	else if (strcmp(GT_LT_1a,"LT") == 0)
	{
		GT_LT_bool_1a = false;
	}
	else
	{
		cout << "error on line 5 of ini file" << endl;
	}
		
	if (strcmp(GT_LT_2a,"GT") == 0)
	{
		GT_LT_bool_2a = true;
	}
	else if (strcmp(GT_LT_2a,"LT") == 0)
	{
		GT_LT_bool_2a = false;
	}
	else
	{
		cout << "error on line 12 of ini file" << endl;
	}

	if (strcmp(GT_LT_3a,"GT") == 0)
	{
		GT_LT_bool_3a = true;
	}
	else if (strcmp(GT_LT_3a,"LT") == 0)
	{
		GT_LT_bool_3a = false;
	}
	else
	{
		cout << "error on line 19 of ini file" << endl;
	}

//////////////////////////////////////////////////////////
	if (strcmp(GT_LT_1b,"GT") == 0)
	{
		GT_LT_bool_1b = true;
	}
	else if (strcmp(GT_LT_1b,"LT") == 0)
	{
		GT_LT_bool_1b = false;
	}
	else
	{
		cout << "error on line 9 of ini file" << endl;
	}
		
	if (strcmp(GT_LT_2b,"GT") == 0)
	{
		GT_LT_bool_2b = true;
	}
	else if (strcmp(GT_LT_2b,"LT") == 0)
	{
		GT_LT_bool_2b = false;
	}
	else
	{
		cout << "error on line 16 of ini file" << endl;
	}

	if (strcmp(GT_LT_3b,"GT") == 0)
	{
		GT_LT_bool_3b = true;
	}
	else if (strcmp(GT_LT_3b,"LT") == 0)
	{
		GT_LT_bool_3b = false;
	}
	else
	{
		cout << "error on line 23 of ini file" << endl;
	}

/////////////////////////////////////////
	if (strcmp(second_var_condition_1b,"TRUE") == 0)
	{
		second_var_condition_1b_bool = true;
	}
	else if (strcmp(second_var_condition_1b,"FALSE") == 0)
	{
		second_var_condition_1b_bool = false;
	}
	else
	{
		cout << "error on line 6 of ini file" << endl;
	}
		
	if (strcmp(second_var_condition_2b,"TRUE") == 0)
	{
		second_var_condition_2b_bool = true;
	}
	else if (strcmp(second_var_condition_2b,"FALSE") == 0)
	{
		second_var_condition_2b_bool = false;
	}
	else
	{
		cout << "error on line 13 of ini file" << endl;
	}

	if (strcmp(second_var_condition_3b,"TRUE") == 0)
	{
		second_var_condition_3b_bool = true;
	}
	else if (strcmp(second_var_condition_3b,"FALSE") == 0)
	{
		second_var_condition_3b_bool = false;
	}
	else
	{
		cout << "error on line 20 of ini file" << endl;
	}

////////////////////////////////////////////

	if (!second_var_condition_1b_bool)
	{
		sprintf(outfilename_1a_count, "%s_%s_%s%2.1f_count_results.csv", scen_or_cntr, var_1a, GT_LT_1a, thresh_1a);
		sprintf(outfilename_1a_sum, "%s_%s_%s%2.1f_sum_results.csv", scen_or_cntr, var_1a, GT_LT_1a, thresh_1a);
	}
	else
	{
		sprintf(outfilename_1a_count, "%s_%s_%s%2.1f_count_2nd_cond_%s_%s%2.1f_results.csv",  scen_or_cntr, var_1a, GT_LT_1a, thresh_1a, var_1b,GT_LT_1b, thresh_1b);
		sprintf(outfilename_1a_sum, "%s_%s_%s%2.1f_sum_2nd_cond_%s_%s%2.1f_results.csv",  scen_or_cntr, var_1a, GT_LT_1a, thresh_1a, var_1b,GT_LT_1b, thresh_1b);
	}
	if (!second_var_condition_2b_bool)
	{
		sprintf(outfilename_2a_count, "%s_%s_%s%2.1f_count_results.csv", scen_or_cntr, var_2a, GT_LT_2a, thresh_2a);
		sprintf(outfilename_2a_sum, "%s_%s_%s%2.1f_sum_results.csv", scen_or_cntr, var_2a, GT_LT_2a, thresh_2a);
	}
	else
	{
		sprintf(outfilename_2a_count, "%s_%s_%s%2.1f_count_2nd_cond_%s_%s%2.1f_results.csv",  scen_or_cntr, var_2a, GT_LT_2a, thresh_2a, var_2b,GT_LT_2b, thresh_2b);
		sprintf(outfilename_2a_sum, "%s_%s_%s%2.1f_sum_2nd_cond_%s_%s%2.1f_results.csv",  scen_or_cntr, var_2a, GT_LT_2a, thresh_2a, var_2b,GT_LT_2b, thresh_2b);
	}
	if (!second_var_condition_3b_bool)
	{
		sprintf(outfilename_3a_count, "%s_%s_%s%2.1f_count_results.csv", scen_or_cntr, var_3a, GT_LT_3a, thresh_3a);
		sprintf(outfilename_3a_sum, "%s_%s_%s%2.1f_sum_results.csv", scen_or_cntr, var_3a, GT_LT_3a, thresh_3a);
	}
	else
	{
		sprintf(outfilename_3a_count, "%s_%s_%s%2.1f_count_2nd_cond_%s_%s%2.1f_results.csv",  scen_or_cntr, var_3a, GT_LT_3a, thresh_3a, var_3b,GT_LT_3b, thresh_3b);
		sprintf(outfilename_3a_sum, "%s_%s_%s%2.1f_sum_2nd_cond_%s_%s%2.1f_results.csv",  scen_or_cntr, var_3a, GT_LT_3a, thresh_3a, var_3b,GT_LT_3b, thresh_3b);
	}
	ofstream outfile_1_count(outfilename_1a_count);
	ofstream outfile_2_count(outfilename_2a_count);
	ofstream outfile_3_count(outfilename_3a_count);

	ofstream outfile_1_sum(outfilename_1a_sum);
	ofstream outfile_2_sum(outfilename_2a_sum);
	ofstream outfile_3_sum(outfilename_3a_sum);

	for (j=1; j<=12; j++) outfile_1_count << "," << j;
	outfile_1_count << endl;

	for (j=1; j<=12; j++) outfile_2_count << "," << j;
	outfile_2_count << endl;

	for (j=1; j<=12; j++) outfile_3_count << "," << j;
	outfile_3_count << endl;

	for (j=1; j<=12; j++) outfile_1_sum << "," << j;
	outfile_1_sum << endl;

	for (j=1; j<=12; j++) outfile_2_sum << "," << j;
	outfile_2_sum << endl;

	for (j=1; j<=12; j++) outfile_3_sum << "," << j;
	outfile_3_sum << endl;


	ifstream infile(infilename);
	// loop through all the data
	for (i=0; i<nsims; i++)
	{
		for (j=1; j<=12; j++)
		{
			count_vec_1[i][j] = 0.0;
			count_vec_2[i][j] = 0.0;
			count_vec_3[i][j] = 0.0;

			sum_of_diffs_1[i][j] = 0.0;
			sum_of_diffs_2[i][j] = 0.0;
			sum_of_diffs_3[i][j] = 0.0;

			no_of_points[i][j] = 0;

		}
		for (k=0; k<10957; k++)
		{
			for (m=0; m<3; m++) infile >> date_time[m];
			for (m=0; m<2; m++) infile >> dummy_int;
			for (m=0; m<10; m++) infile >> data_vector[m];

			no_of_points[i][date_time[1]]++;

			if (!second_var_condition_1b_bool)
			{
				if (GT_LT_bool_1a)
				{
					if (data_vector[var_type_1a] > thresh_1a)
					{
						count_vec_1[i][date_time[1]]++;
						
						sum_of_diffs_1[i][date_time[1]] += data_vector[var_type_1a] - thresh_1a;
					}
				}
				else
				{
					if (data_vector[var_type_1a] < thresh_1a)
					{
						count_vec_1[i][date_time[1]]++;

						sum_of_diffs_1[i][date_time[1]] += thresh_1a - data_vector[var_type_1a];
					}
				}
			}	
			else
			{
				if (GT_LT_bool_1a && GT_LT_bool_1b)
				{
					if (data_vector[var_type_1a] > thresh_1a && data_vector[var_type_1b] > thresh_1b)
					{
						count_vec_1[i][date_time[1]]++;
						
						sum_of_diffs_1[i][date_time[1]] += data_vector[var_type_1a] - thresh_1a;
					}
				}
				else if (!GT_LT_bool_1a && GT_LT_bool_1b)
				{
					if (data_vector[var_type_1a] < thresh_1a && data_vector[var_type_1b] > thresh_1b)
					{
						count_vec_1[i][date_time[1]]++;

						sum_of_diffs_1[i][date_time[1]] += thresh_1a - data_vector[var_type_1a];
					}
				}
				else if (GT_LT_bool_1a && !GT_LT_bool_1b)
				{
					if (data_vector[var_type_1a] > thresh_1a && data_vector[var_type_1b] < thresh_1b)
					{
						count_vec_1[i][date_time[1]]++;

						sum_of_diffs_1[i][date_time[1]] += data_vector[var_type_1a] - thresh_1a;
					}
				}
				else if (!GT_LT_bool_1a && !GT_LT_bool_1b)
				{
					if (data_vector[var_type_1a] < thresh_1a && data_vector[var_type_1b] < thresh_1b)
					{
						count_vec_1[i][date_time[1]]++;

						sum_of_diffs_1[i][date_time[1]] += thresh_1a - data_vector[var_type_1a];
					}
				}
			}
			if (!second_var_condition_1b_bool)
			{
				if (GT_LT_bool_2a)
				{
					if (data_vector[var_type_2a] > thresh_2a)
					{
						count_vec_2[i][date_time[1]]++;
						
						sum_of_diffs_2[i][date_time[1]] += data_vector[var_type_2a] - thresh_2a;
					}
				}
				else
				{
					if (data_vector[var_type_2a] < thresh_2a)
					{
						count_vec_2[i][date_time[1]]++;

						sum_of_diffs_2[i][date_time[1]] += thresh_2a - data_vector[var_type_2a];
					}
				}
			}
			else
			{
				if (GT_LT_bool_2a && GT_LT_bool_2b)
				{
					if (data_vector[var_type_2a] > thresh_2a && data_vector[var_type_2b] > thresh_2b)
					{
						count_vec_2[i][date_time[1]]++;
						
						sum_of_diffs_2[i][date_time[1]] += data_vector[var_type_2a] - thresh_2a;
					}
				}
				else if (!GT_LT_bool_2a && GT_LT_bool_2b)
				{
					if (data_vector[var_type_2a] < thresh_2a && data_vector[var_type_2b] > thresh_2b)
					{
						count_vec_2[i][date_time[1]]++;

						sum_of_diffs_2[i][date_time[1]] += thresh_2a - data_vector[var_type_2a];
					}
				}
				else if (GT_LT_bool_2a && !GT_LT_bool_2b)
				{
					if (data_vector[var_type_2a] > thresh_2a && data_vector[var_type_2b] < thresh_2b)
					{
						count_vec_2[i][date_time[1]]++;

						sum_of_diffs_2[i][date_time[1]] += data_vector[var_type_2a] - thresh_2a;
					}
				}
				else if (!GT_LT_bool_2a && !GT_LT_bool_2b)
				{
					if (data_vector[var_type_2a] < thresh_2a && data_vector[var_type_2b] < thresh_2b)
					{
						count_vec_2[i][date_time[1]]++;

						sum_of_diffs_2[i][date_time[1]] += thresh_2a - data_vector[var_type_2a];
					}
				}
			}
			if (!second_var_condition_3b_bool)
			{
				if (GT_LT_bool_3a)
				{
					if (data_vector[var_type_3a] > thresh_3a)
					{
						count_vec_3[i][date_time[1]]++;
						
						sum_of_diffs_3[i][date_time[1]] += data_vector[var_type_3a] - thresh_3a;
					}
				}
				else
				{
					if (data_vector[var_type_3a] < thresh_3a)
					{
						count_vec_3[i][date_time[1]]++;

						sum_of_diffs_3[i][date_time[1]] += thresh_3a - data_vector[var_type_3a];
					}
				}
			}
			else
			{
				if (GT_LT_bool_3a && GT_LT_bool_3b)
				{
					if (data_vector[var_type_3a] > thresh_3a && data_vector[var_type_3b] > thresh_3b)
					{
						count_vec_3[i][date_time[1]]++;
						
						sum_of_diffs_3[i][date_time[1]] += data_vector[var_type_3a] - thresh_3a;
					}
				}
				else if (!GT_LT_bool_3a && GT_LT_bool_3b)
				{
					if (data_vector[var_type_3a] < thresh_3a && data_vector[var_type_3b] > thresh_3b)
					{
						count_vec_3[i][date_time[1]]++;

						sum_of_diffs_3[i][date_time[1]] += thresh_3a - data_vector[var_type_3a];
					}
				}
				else if (GT_LT_bool_3a && !GT_LT_bool_3b)
				{
					if (data_vector[var_type_3a] > thresh_3a && data_vector[var_type_3b] < thresh_3b)
					{
						count_vec_3[i][date_time[1]]++;

						sum_of_diffs_3[i][date_time[1]] += data_vector[var_type_3a] - thresh_3a;
					}
				}
				else if (!GT_LT_bool_3a && !GT_LT_bool_3b)
				{
					if (data_vector[var_type_3a] < thresh_3a && data_vector[var_type_3b] < thresh_3b)
					{
						count_vec_3[i][date_time[1]]++;

						sum_of_diffs_3[i][date_time[1]] += thresh_3a - data_vector[var_type_3a];
					}
				}
			}
		}
		// write processed run to file
		outfile_1_count << i+1 << ",";
		for (j=1; j<=12; j++) outfile_1_count << (int)count_vec_1[i][j] << ",";
		outfile_1_count << endl;

		outfile_2_count << i+1 << ",";
		for (j=1; j<=12; j++) outfile_2_count << (int)count_vec_2[i][j] << ",";
		outfile_2_count << endl;

		outfile_3_count << i+1 << ",";
		for (j=1; j<=12; j++) outfile_3_count << (int)count_vec_3[i][j] << ",";
		outfile_3_count << endl;

		// write processed run to file
		outfile_1_sum << i+1 << ",";
		for (j=1; j<=12; j++) outfile_1_sum << setprecision(15) << sum_of_diffs_1[i][j] << ",";
		outfile_1_sum << endl;

		outfile_2_sum << i+1 << ",";
		for (j=1; j<=12; j++) outfile_2_sum << setprecision(15) << sum_of_diffs_2[i][j] << ",";
		outfile_2_sum << endl;

		outfile_3_sum  << i+1 << ",";
		for (j=1; j<=12; j++) outfile_3_sum << setprecision(15) << sum_of_diffs_3[i][j] << ",";
		outfile_3_sum << endl;
	}
	

	////////////////////////////// calc mean and sd ////////////////////
	double *total_of_sim_yrs = new double [6];
	double **means = matrix2D_real(6, 13);
	double **sd_vector = matrix2D_real(6, 13);
	// calc overall mean
	for (i=1; i<=12; i++) 
	{
		for (m=0; m<6; m++) total_of_sim_yrs[m] = 0.0;
		for (k=0; k<nsims; k++)
		{
			total_of_sim_yrs[0] += count_vec_1[k][i];
			total_of_sim_yrs[1] += count_vec_2[k][i];
			total_of_sim_yrs[2] += count_vec_3[k][i];

			total_of_sim_yrs[3] += sum_of_diffs_1[k][i];
			total_of_sim_yrs[4] += sum_of_diffs_2[k][i];
			total_of_sim_yrs[5] += sum_of_diffs_3[k][i];

		}
		for (m=0; m<6; m++) means[m][i] = total_of_sim_yrs[m]/(double)nsims;
	}

	// calc SD
	for (i=1; i<=12; i++) 
	{
		for (m=0; m<6; m++) sd_vector[m][i] = 0.0;

		for (k=0; k<nsims; k++)
		{
			sd_vector[0][i] += pow((count_vec_1[k][i] - means[0][i]),2);
			sd_vector[1][i] += pow((count_vec_2[k][i] - means[1][i]),2);
			sd_vector[2][i] += pow((count_vec_3[k][i] - means[2][i]),2);

			sd_vector[3][i] += pow((sum_of_diffs_1[k][i] - means[3][i]),2);
			sd_vector[4][i] += pow((sum_of_diffs_2[k][i] - means[4][i]),2);
			sd_vector[5][i] += pow((sum_of_diffs_3[k][i] - means[5][i]),2);

		}
		for (m=0; m<6; m++) sd_vector[m][i] = sqrt(sd_vector[m][i]/(double)(nsims-1));
		
	}

		// write means/sds to file
		outfile_1_count << "mean" << ",";
		for (j=1; j<=12; j++) outfile_1_count << setprecision(15) << means[0][j] << ",";
		outfile_1_count << endl;
		outfile_1_count << "SD" << ",";
		for (j=1; j<=12; j++) outfile_1_count << setprecision(15) << sd_vector[0][j] << ",";
		outfile_1_count << endl;

		outfile_2_count << "mean" << ",";
		for (j=1; j<=12; j++) outfile_2_count << setprecision(15) << means[1][j] << ",";
		outfile_2_count << endl;
		outfile_2_count << "SD" << ",";
		for (j=1; j<=12; j++) outfile_2_count << setprecision(15) << sd_vector[1][j] << ",";
		outfile_2_count << endl;

		outfile_3_count << "mean" << ",";
		for (j=1; j<=12; j++) outfile_3_count << setprecision(15) << means[2][j] << ",";
		outfile_3_count << endl;
		outfile_3_count << "SD" << ",";
		for (j=1; j<=12; j++) outfile_3_count << setprecision(15) << sd_vector[2][j] << ",";
		outfile_3_count << endl;

		// write means/sds to file
		outfile_1_sum << "mean" << ",";
		for (j=1; j<=12; j++) outfile_1_sum << setprecision(15) << means[3][j] << ",";
		outfile_1_sum << endl;
		outfile_1_sum << "SD" << ",";
		for (j=1; j<=12; j++) outfile_1_sum << setprecision(15) << sd_vector[3][j] << ",";
		outfile_1_sum << endl;

		outfile_2_sum << "mean" << ",";
		for (j=1; j<=12; j++) outfile_2_sum << setprecision(15) << means[4][j] << ",";
		outfile_2_sum << endl;
		outfile_2_sum << "SD" << ",";
		for (j=1; j<=12; j++) outfile_2_sum << setprecision(15) << sd_vector[4][j] << ",";
		outfile_2_sum << endl;

		outfile_3_sum  << "mean" << ",";
		for (j=1; j<=12; j++) outfile_3_sum << setprecision(15) << means[5][j] << ",";
		outfile_3_sum << endl;
		outfile_3_sum  << "SD" << ",";
		for (j=1; j<=12; j++) outfile_3_sum << setprecision(15) << sd_vector[5][j] << ",";
		outfile_3_sum << endl;

	infile.close();
	outfile_1_count.close();
	outfile_2_count.close();
	outfile_3_count.close();

	outfile_1_sum.close();
	outfile_2_sum.close();
	outfile_3_sum.close();

	// delete allocated memory
	delete [] date_time;
	delete [] data_vector;

	free_matrix2D_real(count_vec_1,nsims, 13);
	free_matrix2D_real(count_vec_2,nsims, 13);
	free_matrix2D_real(count_vec_3,nsims, 13);

	free_matrix2D_real(sum_of_diffs_1,nsims, 13);
	free_matrix2D_real(sum_of_diffs_2,nsims, 13);	
	free_matrix2D_real(sum_of_diffs_3,nsims, 13);
	free_matrix2D_real(means,6,13);	
	free_matrix2D_real(sd_vector,6,13);
	delete total_of_sim_yrs;
}

