// memAlloc.h

#ifndef MEMALLOC_H
#define MEMALLOC_H



double **matrix2D_real(long rows, long cols);
void free_matrix2D_real(double **matrix2D, long rows, long cols);

double ***matrix3D_real(long rows, long cols, long slices);
void free_matrix3D_real(double ***m, long rows, long cols, long slices);

int **matrix2D_int(long rows, long cols);
void free_matrix2D_int(int **matrix2D, long rows, long cols);

int ***matrix3D_int(long rows, long cols, long slices);
void free_matrix3D_int(int ***m, long rows, long cols, long slices);

#endif